ca
clear all
rng shuffle

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Includes
addpath(genpath('./utils'));
addpath(genpath('./utils/bin2hex'));
addpath(genpath('./utils/AES'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Definitions
COM_PORT_NUMBER = "COM5";
BAUD_RATE = double(115200);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Variable Initilization

% Number of the last saved attack_data file - default is 0
start_file_number = 0;

% Number of file
file_number = start_file_number;

% Number of encryption saved per trace dataset. Separate trace datasets will be used for ease
numofencryptions = 100;

% Total number of encryptions to be performed - 1st-order : 100.000
total_encryptions = 100000;

% Number of trace datasets
total_runs = total_encryptions/numofencryptions;

% Number of points we save from the points sent by the oscilloscope. Consult 'Curr' value on the instrument
lecroy_num_of_points = 280000;

% Debug flag for capturing
% Set 1 for enabling capturing, 0 for disabling it
flag_capture_oscilloscope = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Execution
for i=start_file_number:total_runs

    % Clear everything except variables used across the scripts
    clearvars -except i BAUD_RATE COM_PORT_NUMBER deviceObj groupObj total_encryptions total_runs numofencryptions flag_capture_oscilloscope lecroy_num_of_points file_number
   
    file_number = file_number+1

    tic

    perform_encryptions;

    toc

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Clear platform

%if flag_capture_oscilloscope == 1 disconnect(deviceObj); end
%if flag_capture_oscilloscope == 1 delete([deviceObj visaObj]); end


